Problem Statement

Bob is going to create a graph with N nodes. The graph will be constructed in two steps. First, Bob will take N isolated vertices, label them 1 through N and color each of them using one of K colors.
Then, Bob will add some directed edges to the graph. For each i between 2 and N, inclusive, Bob may choose a single value j < i such that the nodes i and j have different colors. If he does, he will add the edge from i to j to his graph. Note
that Bob may choose not to add any edge from node i, even if there are some valid choices of j.

Two graphs are considered the same if they have the same node colors and the same set of edges.

You are given the ints N and K. Compute and return the number of different graphs Bob may construct, modulo 1,000,000,007.

Definition

  • ClassColorfulLineGraphsDiv2
  • MethodcountWays
  • Parametersint , int
  • Returnsint
  • Method signatureint countWays(int N, int K)
(be sure your method is public)

Limits

  • Time limit (s)2.000
  • Memory limit (MB)256

Constraints

  • N will be between 1 and 100, inclusive.
  • K will be between 1 and 3, inclusive.

Test cases

    • N3
    • K2

    Returns24

    The 24 different graphs are shown below. In each picture, the vertices have labels 1, 2, 3 from the left to the right.

    • N15
    • K2

    Returns789741546

    • N100
    • K1

    Returns1

    • N1
    • K3

    Returns3

    • N100
    • K3

    Returns

    492594064

  1. +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    There can be at most 3 colors. So how about we solve for 3 colors, then we can adapt the solution for fewer number of colors with small tweaks.

    The problem statement describes the decision as first choosing colors and then creating the edges. But the actual rules for counting the unique setups combines the two together. Let's try to make the decision about picking a color AND an edge for each vertex.

    Imagine we've already picked colors and edges for the first i nodes,
    let's decide the i-th
    node. We can pick one of 3 colors:

    • Pick color A. Now we have to decide the edge. We can choose to connect vertex i to
      any of the previous vertices as long as they have a different color. Since this is a counting problem, let's keep in mind the counts for each color (assume 3 colors) : a, b and c.
      We cannot connect to color a,
      so there are b+c vertices
      we can connect this vertex to. There is an additional option: Don't connect the vertex at all. This gives b+c+1 options.
      Note that later vertices don't need to know what edge we picked, only the color.
    • If we pick color B: There are 1+a+c options.
    • 1+a+b options
      in case color C is picked.

    The idea is that we can just increment the count of the respective color and move on to the next i.
    Also note that i=a+b+c,
    because there were i vertices
    so the sum of all colors must be i.
    This helps us do a dynamic programming solution. Let's name f(a,b,c) to
    the number of ways to pick colors and edges for vertices starting from i=a+b+c onwards,
    assuming there were a, b and c vertices
    of each color among the first i vertices.

    • Base case: a+b+c=N.
      This means that we have already made a decision for all the vertices and there is nothing else to do. One way to do nothing: The result is 1.
    • Else there are 3 options:
      • We can pick color A.
        This means (1+b+c) options
        for the edge. The number of A vertices
        is incremented. Between picking the edge and picking the next colors/edges we have two independent decisions, so we multiply: (1+b+c)⋅f(a+1,b,c).
      • Or pick color B: (1+a+c)⋅f(a,b+1,c).
      • Or C: (1+a+b)⋅f(a,b,c+1).

      The addition of these 3 values is the result for f(a,b,c).

    Fewer colors

    When there are two colors, we can just disable the part where we pick color C.
    The state can still be (a,b,c),
    but c will
    always be 0.

    When there is one color, we can just return the number of graphs of size N that
    follow this rule OR we can do the same trick as for K=2 and
    just disable the part where we decide to use color B and C.

    Code

    The idea with that recurrence relation is that it is acyclic and the number of states is not very large O(n3).
    We can implement the recurrence using memoization or iteratively (dynamic programming) to guarantee O(n3) run
    time.

    const int MOD = 1000000007;
    
    int dp[101][101][101];
    
    int N, K;
    
    int f(int a, int b, int c)
    {
    int & res = dp[a][b][c];
    if (res == -1) {
    if (a + b + c == N) {
    // the end
    res = 1;
    } else {
    res = 0;
    long p, q;
    // color vertex with color a
    p = 1 + b + c;
    q = f(a + 1, b, c);
    res += (int)( (p * q) % MOD );
    res %= MOD; // color vertex with color b
    if (K >= 2) {
    p = 1 + a + c;
    q = f(a, b + 1, c);
    res += (int)( (p * q) % MOD );
    res %= MOD;
    } // color vertex with color c
    if (K >= 3) {
    p = 1 + a + b;
    q = f(a, b, c + 1);
    res += (int)( (p * q) % MOD );
    res %= MOD;
    }
    }
    }
    return res;
    } int countWays(int N, int K)
    {
    this->N = N;
    this->K = K;
    memset(dp, -1, sizeof(dp));
    return f(0,0,0);
    }

DP SRM 661 Div2 Hard: ColorfulLineGraphsDiv2的更多相关文章

  1. TopCoder SRM 301 Div2 Problem 1000 CorrectingParenthesization(区间DP)

    题意  给定一个长度为偶数的字符串.这个字符串由三种括号组成. 现在要把这个字符串修改为一个符合括号完全匹配的字符串,改变一个括号的代价为$1$,求最小总代价. 区间DP.令$dp[i][j]$为把子 ...

  2. Topcoder Srm 673 Div2 1000 BearPermutations2

    \(>Topcoder \space Srm \space 673 \space Div2 \space 1000 \space BearPermutations2<\) 题目大意 : 对 ...

  3. Topcoder Srm 671 Div2 1000 BearDestroysDiv2

    \(>Topcoder \space Srm \space 671 \space Div2 \space 1000 \space BearDestroysDiv2<\) 题目大意 : 有一 ...

  4. SRM 657 DIV2

    -------一直想打SRM,但是感觉Topcoder用起来太麻烦了.题目还是英文,不过没什么事干还是来打一打好了.但是刚注册的号只能打DIV2,反正我这么弱也只适合DIV2了.. T1: 题目大意: ...

  5. Topcoder srm 632 div2

    脑洞太大,简单东西就是想复杂,活该一直DIV2; A:水,基本判断A[I]<=A[I-1],ANS++; B:不知道别人怎么做的,我的是100*N*N;没办法想的太多了,忘记是连续的数列 我们枚 ...

  6. SRM 628 DIV2

    250  想想就发现规律了. 500  暴力,括号匹配. 1000 给一个f数组,如果i存在,那么f[i]也得存在,问这样的集合有多少种. 先拓扑一下,dp[i] = mul(dp[son]+1)最后 ...

  7. Topcoder SRM 683 Div2 - C

    树形Dp的题,根据题意建树. DP[i][0] 表示以i为根节点的树的包含i的时候的所有状态点数的总和 Dp[i][1] 表示包含i结点的状态数目 对于一个子节点v Dp[i][0] = (Dp[v] ...

  8. 记第一次TopCoder, 练习SRM 583 div2 250

    今天第一次做topcoder,没有比赛,所以找的最新一期的SRM练习,做了第一道题. 题目大意是说 给一个数字字符串,任意交换两位,使数字变为最小,不能有前导0. 看到题目以后,先想到的找规律,发现要 ...

  9. SRM 595 DIV2 1000

    数位DP的感觉,但是跟模版不是一个套路的,看的题解,代码好理解,但是确实难想. #include <cstdio> #include <cstring> #include &l ...

随机推荐

  1. 【弱省胡策】Round #0 Flower Dance DP

    Flower Dance Time Limit: 20 Sec  Memory Limit: 256 MB 题目连接 http://162.105.80.126/contest/%E3%80%90%E ...

  2. hihocoder1322 树结构判定(161周)

    hihocoder1322 : 树结构判定(161周) 题目链接 思路: 无向图中判断是不是一棵树. 并查集判断.判断是不是只有一个连通分量.并且该联通分量中没有环.没有环的判定很简单就是看边的数目和 ...

  3. Android EditText 限制输入为ip类型

    editText.setInputType(InputType.TYPE_CLASS_NUMBER); String digits = "0123456789."; editTex ...

  4. WebDriver工作原理

    http://www.cnblogs.com/timsheng/archive/2012/06/12/2546957.html 通过研究selenium-webdriver的源码,笔者发现其实webd ...

  5. JSP如何导入ckeditor

    <textarea rows="3" cols="100" id="editor1"></textarea> < ...

  6. 🌅 使用 Dawn 快速搭建 React 项目!

    开发一个 React 项目,通常避免不了要去配置 Webpack 和 babel 之类,以支持 commonjs 或 es 模块及各种 es 新语法,及进行 jsx 语法的转义.当然也可以用 crea ...

  7. Latex作者单位的写法—AND 首页脚注

    IEEE会议的模板 以四个作者为例 正常: 作者单位如果名字较短,可以直接写在作者对应的下面,邮箱可以对应写在再接下来的下面. 一 如果邮箱较长,可以用\thanks{ }命令将其变为脚注.例如: ~ ...

  8. Python任务调度模块 – APScheduler。动态修改调度时间间隔

    APScheduler可以把调度任务放到内存里,也可以把任务放到数据库里,那么如何交互式修改定时任务的执行时间间隔或者下次执行时间呢? 方案一:把定时任务放到数据库里,修改数据库里任务的调度时间 方案 ...

  9. MySQL索引优化案例

    这里我们分成三种情况进行分析,分别是单表,两表,三表 1.单表 CREATE TABLE IF NOT EXISTS `article`( `id` ) NOT NULL PRIMARY KEY AU ...

  10. POJ 2046 Gap 搜索- 状态压缩

    题目地址: http://poj.org/problem?id=2046 一道搜索状态压缩的题目,关键是怎样hash. AC代码: #include <iostream> #include ...